%define anolis_release 2
%bcond_without python3

Name: libtalloc
Version: 2.4.1
Release: %{anolis_release}%{?dist}
Summary: The talloc library
License: LGPLv3+
URL: https://talloc.samba.org/

Source0: https://www.samba.org/ftp/talloc/talloc-%{version}.tar.gz

BuildRequires: make
BuildRequires: gcc
BuildRequires: libxslt
BuildRequires: docbook-style-xsl
%if %{with python3}
BuildRequires: python3-devel
%endif
BuildRequires: doxygen
BuildRequires: gnupg2

Provides: bundled(libreplace)
Obsoletes: python2-talloc < 2.2.0
Obsoletes: python2-talloc-devel < 2.2.0

%description
A library that implements a hierarchical allocator with destructors.

%package devel
Summary: Developer tools for the Talloc library
Requires: libtalloc = %{version}-%{release}

%description devel
Header files needed to develop programs that link against the Talloc library.

%if %{with python3}
%package -n python3-talloc
Summary: Python bindings for the Talloc library
Requires: libtalloc = %{version}-%{release}
%{?python_provide:%python_provide python3-talloc}

%description -n python3-talloc
Python 3 libraries for creating bindings using talloc

%package -n python3-talloc-devel
Summary: Development libraries for python3-talloc
Requires: python3-talloc = %{version}-%{release}
%{?python_provide:%python_provide python3-talloc-devel}

%description -n python3-talloc-devel
Development libraries for python3-talloc
%endif

%prep
%autosetup -n talloc-%{version} -p1

%build
export python_LDFLAGS=""

%configure --disable-rpath \
           --disable-rpath-install \
           --bundled-libraries=NONE \
           --builtin-libraries=replace \
           --disable-silent-rules

%make_build
doxygen doxy.config

%check
%make_build check

%install
%make_install

# Install API docs
cp -a doc/man/man3 %{buildroot}%{_mandir}

%generate_compatibility_deps

%files
%dir %{abidir}
%{_libdir}/libtalloc.so.*
%{abidir}/libtalloc*.dump

%files devel
%{_includedir}/talloc.h
%{_libdir}/libtalloc.so
%{_libdir}/pkgconfig/talloc.pc
%{_mandir}/man3/talloc*.3*
%{_mandir}/man3/libtalloc*.3*

%if %{with python3}
%files -n python3-talloc
%{_libdir}/libpytalloc-util.cpython*.so.*
%{python3_sitearch}/talloc.cpython*.so
%{abidir}/talloc.cpython*.dump

%files -n python3-talloc-devel
%{_includedir}/pytalloc.h
%{_libdir}/pkgconfig/pytalloc-util.cpython-*.pc
%{_libdir}/libpytalloc-util.cpython*.so
%{abidir}/libpytalloc-util.cpython*.dump
%endif

%changelog
* Tue Mar 12 2024 Bo Ren <rb01097748@alibaba-inc.com> - 2.4.1-2
- Rebuild with python3.11

* Thu Jul 27 2023 Funda Wang <fundawang@yeah.net> - 2.4.1-1
- New version 2.4.1

* Fri Jan 27 2023 Funda Wang <fundawang@yeah.net> - 2.4.0-1
- New version 2.4.0

* Thu Oct 20 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.3.4-2
- optimise spec file

* Mon Sep 19 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.3.4-1
- update to 2.3.4

* Tue Mar  8 2022 Liwei Ge <liwei.glw@linux.alibaba.com> - 2.3.3-1
- Init version from upstream v2.3.3
